;###############################################################################
;
;	PIC IR REPEATER
;
;		Assemble by pa-3.0.5s(b5e0048474cce2a1ba49a54faf9b1e86 */usr/local/bin/pa.exe)
;

;-------------------------------------------------------------------------------
;
;	إå
;
		include	my12f675.h
		.16f84				; PIC16F84()

;-------------------------------------------------------------------------------
;
;	ϥݡ
;
MYTRIS		equ	00100000b		; (0:, 1:())
SENSOR		equ	  5
IRLED		equ	       0
;TESTLED	equ	     2

;-------------------------------------------------------------------------------
;
;	EEPROM
;
		eeorg	0			; EEDATA

;-------------------------------------------------------------------------------
;
;	ꥻ
;
		org	20h			; ޥå

waitCntS	ds	1			; Ԥѥ
waitCntM	ds	1
waitCntL	ds	1

;-------------------------------------------------------------------------------
;
;	ץॻ
;
		org	00h			; ꥻåȥ٥
		JP	start

;-------------------------------------------------------------------------------
;
;	߽
;
		org	04h			; ߥ٥
		JP	start

;-------------------------------------------------------------------------------
;
;	å׽
;
start
		RES	RP0, (STATUS)		; Х0

		CLR	(GPIO)			; ݡȤ
		LD	A, 00000111b
		LD	(CMCON), A		; ѥ졼OFF

		SET	RP0, (STATUS)		; Х1

		CLR	(ANSEL)			; A/DѴOFF
		LD	A, MYTRIS		; :11111111b
		LD	(TRISIO), A		; ݡ
timerSet
		CLR	(WDT)			; åɥåޡץꥹ饯ꥢ

		LD	A, 11111111b		; :11111111b
		LD	(OPTION), A		; 7:GPIOץ륢å(0:Ѥ)
						; 6:GP2ߥݡѲ(0:Ω)
						; 5:TMR0åӥå(0:)
						; 4:GP2ѲTMR0ûߥ(0:Ω)
						; 3:ץꥹƥӥå(0:TMR0)
						; 2~0ץꥹ졼ӥå(111:1/256)

		RES	RP0, (STATUS)		; Х0

		CLR	(TMR0)			; ޥꥢ
intStart
		LD	A, 00000000b		; :00000000b
		LD	(INTCON), A		; 7:Хߥ֥͡
						; 5:TMR0Сեߥ֥͡
						; 4:GP2ݡѲߥ֥͡
						; 3:ݡѲߥ֥͡

;--------------------------------------------------------------------------------
;
;	20üLEDǽ(å®ٷ¬)
;
;getClock
;		SET	TESTLED, (GPIO)
;
;		LD	A, 100			; 100ꤹȡ
;		CALL	WAITnx01sm25us		; 2Ԥ 100 x 100ms - 25us 񤹤
;		LD	A, 6			; 10ꤹȡ
;		CALL	WAITnx3p5us		; 2Ԥ 6 x 3 + 5 = 23us 
;
;		RES	TESTLED, (GPIO)
;
;		LD	A, 100			; 100ꤹȡ
;		CALL	WAITnx01sm25us		; 2Ԥ 100 x 100ms - 25us 񤹤
;		LD	A, 6			; 10ꤹȡ
;		CALL	WAITnx3p5us		; 2Ԥ 6 x 3 + 5 = 23us 
;
;		JP	getClock

;--------------------------------------------------------------------------------
;
;	ᥤ
;
MAIN
		CLR	(WDT)			; 24
		BIT	SENSOR, (GPIO)		; 25
		JP	NZ, MAIN		; 26

		SET	IRLED, (GPIO)		; 27 (IR LED ON)
		NOP				; 01
		NOP				; 02
		NOP				; 03
		NOP				; 04
		NOP				; 05
		NOP				; 06
		NOP				; 07
		NOP				; 08
		NOP				; 09
		NOP				; 10
		NOP				; 11
		NOP				; 12
		RES	IRLED, (GPIO)		; 13 (IR LED OFF)
		NOP				; 14
		NOP				; 15
		NOP				; 16
		NOP				; 17
		NOP				; 18
		NOP				; 19
		NOP				; 20
		NOP				; 21

		JP	MAIN			; 22, 23

;--------------------------------------------------------------------------------
;
;	Ԥ()
;
;		LD	A, 10			; 10ꤹȡ
;		CALL	WAITnx3p5us		; 2Ԥ 10 x 3 + 5 = 35us 
;
WAITnx3p5us
		LD	(waitCntS), A
WAITnx3p5us1
		DJNZ	(waitCntS), WAITnx3p5us1
		RET

;--------------------------------------------------------------------------------
;
;	Ԥ()
;
;		LD	A, 200			; 0.1äξ硢200ꤹȡ
;		CALL	WAITnx500m35us		; 2Ԥ 200 x 500 - 35 = 99.965ms 񤹤
;
WAITnx500m35us
		LD	(waitCntM), A
		JP	WAITnx500m35us2
WAITnx500m35us1	NOP
		LD	A, 12			;  12 x 3 + 5 =  41us
		CALL	WAITnx3p5us		;		λԤ
WAITnx500m35us2	LD	A, 150			; 150 x 3 + 5 = 455us
		CALL	WAITnx3p5us		;		λԤ
		DJNZ	(waitCntM), WAITnx500m35us1
		RET

;--------------------------------------------------------------------------------
;
;	Ԥ()
;
;		LD	A, 10			; 1äξ硢10ꤹȡ
;		CALL	WAITnx01sm25us		; 2Ԥ 10 x 100ms - 25us 񤹤
;
WAITnx01sm25us
		LD	(waitCntL), A
		JP	WAITnx01sm25us2
WAITnx01sm25us1	LD	A, 9
		CALL	WAITnx3p5us
WAITnx01sm25us2	LD	A, 200
		CALL	WAITnx500m35us
		DJNZ	(waitCntL), WAITnx01sm25us1
		RET

